# -*- coding: utf-8 -*-
#
# 2011.6.6

import Tkinter as Tk
import tkFileDialog
from random import *
from graph import *
import sys

########## パラメータ設定 ##########

########## 大域変数 ##########

CWIDTH  = 600
CHEIGHT = 600
STEPS = 32
TIMING = 1
items = []
g = Graph(1)
history = []

graphnames = ["完全グラフ Kn", "空グラフ Nn", "完全二部グラフ Km,n", "閉路 Cn", 
              #"n 点の有向閉路",
              "車輪グラフ Wn", "n 点星グラフ ", 
              #"n 次元立方体グラフ Qn",
              "ピータスングラフ",
              "正四面体グラフ", "立方体グラフ", "正八面体グラフ",
              "正十二面体グラフ", "正二十面体グラフ",
              "ランダムグラフ", "ランダムな二部グラフ",
              "ランダムな重み付き二部グラフ"]

class ScrolledListbox(Tk.Listbox):
    """ Listbox with vertical scroll bar """
    
    def __init__(self, master, **key):
        self.frame = Tk.Frame(master)
        self.yscroll = Tk.Scrollbar (self.frame, orient = Tk.VERTICAL)
        self.yscroll.pack(side=Tk.RIGHT, fill=Tk.Y, expand=1)
        key['yscrollcommand'] = self.yscroll.set
        Tk.Listbox.__init__(self, self.frame, **key)
        self.pack(side=Tk.LEFT, fill=Tk.BOTH, expand=1)
        self.yscroll.config(command = self.yview)

        # Copy geometry methods of self.frame 
        for m in (Tk.Pack.__dict__.keys() + Tk.Grid.__dict__.keys() + Tk.Place.__dict__.keys()):
            m[0] == '_' or m == 'config' or m == 'configure' or \
                setattr(self, m, getattr(self.frame, m))
            
########## メイン・フレーム ##########

class Frame(Tk.Frame):

    def __init__(self, master = None):
        Tk.Frame.__init__(self, master, height = 620, width = 850)
        self.master.title("塩田先生のグラフ描画ツール Python 版（開発中）")  # タイトル
        self.master.geometry("+0+0")  # 画面左上からの相対位置

        self.sv = Tk.StringVar()
        self.label0 = Tk.Label(self, textvariable = self.sv, relief = Tk.FLAT, bg = "white", bd = 2)
        self.label0.place(x = 2, y = 0, width = CWIDTH, height = 20)

        self.cvs = Tk.Canvas(self, width = CWIDTH, height = CHEIGHT, background = "white")
        self.cvs.place(x = 0, y = 20)
        
        self.b1 = Tk.Button(self, text = "頂点シャッフル", command = self.shuffle)
        self.b1.place(x = 610, y = 0, width = 230)
        self.b2 = Tk.Button(self, text = "スプリング法", command = self.spring)
        self.b2.place(x = 610, y = 25, width = 230)
        self.b3 = Tk.Button(self, text = "3Dスプリング法", command = self.TDspring)
        self.b3.place(x = 610, y = 50, width = 230)
        self.b4 = Tk.Button(self, text = "最大マッチング", command = self.maxmatch)
        self.b4.place(x = 610, y = 75, width = 230)
        self.b5 = Tk.Button(self, text = "前へ戻る", command = self.backward)
        self.b5.place(x = 610, y = 100, width = 230)
        
        self.select = Tk.LabelFrame(self, text = 'グラフの種類')
        self.select.place(x = 610, y = 150, width = 230, height = 180)
        self.listbox = ScrolledListbox(self.select, width = 28, height = 8)
        self.listbox.grid()
        self.listbox.bind("<Double-Button-1>", self.change_graph)
        #self.listbox.bind("<Button-1>", self.change_graph)
        for name in graphnames:
            self.listbox.insert(Tk.END, name)

        self.label1 = Tk.Label(self, text = "パラメータ m :")
        self.label1.place(x = 610, y = 350, width = 90)
        self.iv1 = Tk.IntVar()
        self.iv1.set(5)
        self.entry1 = Tk.Entry(self, textvariable = self.iv1)
        self.entry1.place(x = 710, y = 350, width = 40)
        
        self.label2 = Tk.Label(self, text = "パラメータ n :")
        self.label2.place(x = 610, y = 375, width = 90)
        self.iv2 = Tk.IntVar()
        self.iv2.set(5)
        self.entry2 = Tk.Entry(self, textvariable = self.iv2)
        self.entry2.place(x = 710, y = 375, width = 40)
        
        self.label3 = Tk.Label(self, text = "辺の比率 (%) :")
        self.label3.place(x = 610, y = 400, width = 90)
        self.iv3 = Tk.IntVar()
        self.iv3.set(30)
        self.entry3 = Tk.Entry(self, textvariable = self.iv3)
        self.entry3.place(x = 710, y = 400, width = 40)
        
        self.label4 = Tk.Label(self, text = "引力 :")
        self.label4.place(x = 610, y = 425, width = 90)
        self.iv4 = Tk.IntVar()
        self.iv4.set(g.AttractionConstant)
        self.entry4 = Tk.Entry(self, textvariable = self.iv4)
        self.entry4.place(x = 710, y = 425, width = 40)

        self.label5 = Tk.Label(self, text = "斥力 :")
        self.label5.place(x = 610, y = 450, width = 90)
        self.iv5 = Tk.IntVar()
        self.iv5.set(g.RepulsionConstant)
        self.entry5 = Tk.Entry(self, textvariable = self.iv5)
        self.entry5.place(x = 710, y = 450, width = 40)        

    def change_graph(self, event):
        global g
        tup = self.listbox.curselection()
        if tup:
            name = graphnames[int(tup[0])]
            if name == "完全グラフ Kn":
                g = CompleteGraph(self.iv2.get())
            if name == "空グラフ Nn":
                g = Graph(self.iv2.get())
            if name == "ランダムグラフ":
                g = RandomGraph(self.iv2.get(), self.iv3.get() / 100.0)
            if name == "ランダムな二部グラフ":
                g = RandomBipartiteGraph(self.iv1.get(), self.iv2.get(), self.iv3.get() / 100.0)
            if name == "ランダムな重み付き二部グラフ":
                g = RandomWeightedBipartiteGraph(self.iv1.get(), self.iv2.get(), self.iv3.get() / 100.0, 10)
            if name == "正四面体グラフ":
                g = PlatonicGraph4()
            if name == "立方体グラフ":
                g = PlatonicGraph6()
            if name == "正八面体グラフ":
                g = PlatonicGraph8()
            if name == "正十二面体グラフ":
                g = PlatonicGraph12()
            if name == "正二十面体グラフ":
                g = PlatonicGraph20()
            if name == "完全二部グラフ Km,n":
                g = CompleteBipartiteGraph(self.iv1.get(), self.iv2.get())
            if name == "閉路 Cn":
                g = Cycle(self.iv2.get())
            if name == "ピータスングラフ":
                g = PetersenGraph()
            if name == "n 点星グラフ ":
                g = StarGraph(self.iv2.get())
            if name == "車輪グラフ Wn":
                g = WheelGraph(self.iv2.get())
#           if name == "n 次元立方体グラフ Qn":
#                g = kDimensionalQubicGraph(4)

                
            self.register()
            self.draw(g)            

    ########## 描画 ##########
 
    def draw(self, h):
        global items
        
        ########## キャンバスのアイテムの初期化 ##########        

        for p in items:
            self.cvs.delete(p)
        count = 0
        items = []

        n = h.ord
        for i in range(0, n):
            x1 = h.vtx[i].x
            y1 = h.vtx[i].y
            p = self.cvs.create_oval(x1 - 5, y1 - 5, x1 + 5, y1 + 5, fill = "black")
            items.append(p)
            for j in range(0, n):
                if h.adj[i][j]:
                    x2 = h.vtx[j].x
                    y2 = h.vtx[j].y
                    p = self.cvs.create_line(x1, y1, x2, y2, width = 1)
                    items.append(p)

                    if i > j and h.wt == 1:
                        x3 = (2 * x1 + 3 * x2) / 5.0
                        y3 = (2 * y1 + 3 * y2) / 5.0
                        #p = self.cvs.create_oval(x3 - 15, y3 - 15, x3, y3, fill = "white",outline = "white")
                        #items.append(p)
                        p = self.cvs.create_text(x3, y3, font = "courier 18 bold", fill = "blue", text = "%d" % h.adj[i][j])
                        items.append(p)
            
        ########## データの表示 ##########

        self.sv.set("頂点数 : %d,  辺数 : %d" % (h.ord, h.size))
        self.iv4.set(h.AttractionConstant)
        self.iv5.set(h.RepulsionConstant)

    ########## マッチング描画 ##########
 
    def drawwithmatching(self, h, m, vl):
        global items
        
        ########## キャンバスのアイテムの初期化 ##########        

        for p in items:
            self.cvs.delete(p)
        count = 0
        items = []

        n = h.ord
        for i in range(0, n):
            x1 = h.vtx[i].x
            y1 = h.vtx[i].y
            if VertexDegree(m, i) == 0:
                p = self.cvs.create_oval(x1 - 5, y1 - 5, x1 + 5, y1 + 5, fill = "black")
                items.append(p)
            for j in range(0, n):
                if h.adj[i][j]:
                    x2 = h.vtx[j].x
                    y2 = h.vtx[j].y
                    if m.adj[i][j] == 0:
                        p = self.cvs.create_line(x1, y1, x2, y2, width = 1, fill = "black")
                        items.append(p)

        for i in range(0, n):
            x1 = h.vtx[i].x
            y1 = h.vtx[i].y
            if VertexDegree(m, i) > 0:
                p = self.cvs.create_oval(x1 - 5, y1 - 5, x1 + 5, y1 + 5, fill = "red", outline = "red")                
                items.append(p)        
            for j in range(0, n):
                if h.adj[i][j]:
                    x2 = h.vtx[j].x
                    y2 = h.vtx[j].y
                    if m.adj[i][j] > 0:
                        p = self.cvs.create_line(x1, y1, x2, y2, width = 2, fill = "red")
                        items.append(p)

                    if i > j and h.wt == 1:
                        x3 = (2 * x1 + 3 * x2) / 5.0
                        y3 = (2 * y1 + 3 * y2) / 5.0
                        #p = self.cvs.create_oval(x3 - 15, y3 - 15, x3, y3, fill = "white",outline = "white")
                        #items.append(p)
                        p = self.cvs.create_text(x3, y3, font = "courier 18 bold", fill = "blue", text = "%d" % h.adj[i][j])
                        items.append(p)

                    
        ########## データの表示 ##########

        if h.wt == 0:
            if 2 * m.size == h.ord:
                self.sv.set("頂点数 : %d,  辺数 : %d,  完全マッチング" % (h.ord, h.size))
            else:
                self.sv.set("頂点数 : %d,  辺数 : %d,  マッチングサイズ : %d" % (h.ord, h.size, vl))
        else:
            self.sv.set("頂点数 : %d,  辺数 : %d,  マッチングの重み : %d" % (h.ord, h.size, vl))

    ########## アニメーション ##########
 
    def animation(self, h0, h1, t):
        
        global items
        global STEPS

        h = GraphCopy(h0)
        if t > 0:
            w = (sin((t - (STEPS / 2.0)) * pi / STEPS) + 1) / 2.0
            w = pow(w, 3)
            for i in range(0, h0.ord):
                h.vtx[i].x = h1.vtx[i].x * w + h0.vtx[i].x * (1 - w)
                h.vtx[i].y = h1.vtx[i].y * w + h0.vtx[i].y * (1 - w)
        self.draw(h)
        if t < STEPS:
            t += 1
            self.cvs.after(TIMING, self.animation, h0, h1, t)

    def randomgraph(self):
        global g
        self.register()
        g = RandomGraph(50, 0.13)
        self.draw(g)

    def shuffle(self):
        global g
        self.register()
        h = GraphCopy(g)
        g = VertexShuffle(g)
        self.animation(h, g, 0)
        
    def spring(self):
        global g
        g.AttractionConstant = self.iv4.get()
        g.RepulsionConstant = self.iv5.get()
        self.register()
        h = GraphCopy(g)
        g = SpringMethod(g)
        self.animation(h, g, 0)
        
    def TDspring(self):
        global g
        g.AttractionConstant = self.iv4.get()
        g.RepulsionConstant = self.iv5.get()
        self.register()
        h = GraphCopy(g)
        g = TDSpringMethod(g)
        self.animation(h, g, 0)

    def randombipartitegraph(self):
        global g
        self.register()
        g = RandomBipartiteGraph(10, 10, 0.1)
        self.draw(g)

    def maxmatchb(self):
        global g
        if g.bip == 1:
            vl, m = MaxMatchingBipartite(g)
            self.drawwithmatching(g, m)

    def maxmatch(self):
        global g
        if g.wt == 0:
            vl, m = MaxMatching(g)
            self.drawwithmatching(g, m, vl)
        else:
            if g.bip == 1:
                vl, m = MaxMatchingWeightedBipartite(g)
                self.drawwithmatching(g, m, vl)
            else:
                print "重み付きの一般のグラフについては未完成です。"

    def backward(self):
        global g
        global history
        if len(history) > 0:
            g = GraphCopy(history[-1])
            history.pop()
            self.draw(g)
        
    def register(self):
        global g
        global history
        history.append(GraphCopy(g))
        if len(history) > 64:
            history.pop(0)
        

########## メイン・ルーチン ##########

if __name__ == '__main__':
    f1 = Frame()
    f1.pack()
    f1.mainloop()
	
