#!/bin/env python
# -*- coding: utf-8 -*-

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

from time import *

def PairPartition(n):
    if n == 2:
        return [[[0, 1]]]
    else:
        x = PairPartition(n - 2)
        y = []
        for i in range(1, n):
            a = [0, i]
            b = range(1, i) + range(i + 1, n)
            c = []
            for d in x:
                z = [a]
                for e in d:
                    z.append([b[e[0]], b[e[1]]])
                y.append(z)
        return y

print u"ランダムな重み付きグラフで郵便配達員問題を解きます。"
print u"グラフの頂点数を入力してください。"
n = input()
print u"辺の割合を入力してください。"
rate = input()

print
print u"グラフ作成中 ..."
t0 = time()
while 1:
    g = RandomWeightedGraph(n, rate, 9)
    if ConnectedQ(g):
        break
t1 = time()

if graph_output:
    WriteGraph(g)
print u"グラフ作成時間 =", t1 - t0

h = SimplifiedGraph(g)

ok = "y"
ov = []
for i in range(0, n):
    if VertexDegree(h, i) % 2 == 1:
        ov.append(i)
print u"奇数次数の頂点は",
print ov
m = len(ov)
if m > 14:
    print u"奇数次数の頂点が 16 個以上あります。"
    print u"膨大な計算時間が掛かりますが宜しいですか。[y or n] ",
    ok = raw_input()

if ok == "y":
    print
    print u"探索中 ..."
    t0 = time()            

    if m > 0:
        dist = []
        path = []
        for i in range(0, m):
            dist.append([0] * m)
            path.append([0] * m)
        for i in range(0, m):
            for j in range(i + 1, m):
                u = ov[i]
                v = ov[j]
                d, p = Dijkstra(g, u, v)
                dist[i][j] = d
                path[i][j] = p           
        mi = 2 ** 64
        pp = PairPartition(m)
        for x in pp:
            a = 0
            q = []
            for y in x:
                i = y[0]
                j = y[1]
                a += dist[i][j]
                q.append(path[i][j])
            if a < mi:
                q0 = ListCopy(q)
                mi = a
        print u"２回通る道は",
        print q0
        for p in q0:
            for i in range(0, len(p) - 1):
                h = AddEdge(h, p[i], p[i + 1])

    if graph_output:
        WriteGraph(h)
    w = EulerianCircuit(h)
    t1 = time()
    print u"最短の配達路は", w
    print u"探索時間 =", t1 - t0
    

