#-*- coding: utf-8 -*-
# Chromatic.py
#
# requires graph.py, pol.py

from graph import *
from pol import *

def ChromaticPol(g):
    n = g.ord
    if EmptyGraphQ(g):
        return monomial(n)
    else:
        for u in range(0, n):
            for v in range(u + 1, n):
                if g.adj[u][v] > 0:
                    h = RemoveEdge(g, u, v)
                    k = SimplifiedGraph(ContractEdge(g, u, v))
                    return polsub(ChromaticPol(h), ChromaticPol(k))

def ChromaticNumber(g):
    f = ChromaticPol(g)
    k = -1
    while 1:
        k += 1
        h = linpol(1, -k)
        e = 0
        q, r = poldivmonic(f, h)
        while polzeroq(r):
            e += 1
            q0 = q
            q, r = poldivmonic(q, h);
        f = q0
        if e == 0:
            break
    return k

def ChromaticInformation(g):
    f = ChromaticPol(g)
    f0 = polcopy(f)
    lf = []
    k = -1
    while 1:
        k += 1
        h = linpol(1, -k)
        e = 0
        q, r = poldivmonic(f, h)
        while polzeroq(r):
            e += 1
            q0 = q
            q, r = poldivmonic(q, h);
        f = q0
        if e > 0:
            lf.append(e)
        if e == 0:
            break
    return [k, f0, f, lf]

